# -*- my-source-delegate: "example-model-B.R" -*-
# FHE 24 Sep 2022
# from /home/frederik/bpbp/fg-diag.R

# this is sourced by other files, to get correct plots
# source example-model-bare.R
# or example-model-B.R

# FHE 24 Sep 2022 added devw=4, so no longer square


# FHE ? Apr 2020
# first attempt at drawing a diagram. this became plotfg.R

library(diagram)
mysource("placeplot.R")

mysource("once.R")

# FHE 24 Sep 2022 make it sourceable, see example-model-bare.R
#outfn="ex-model.pdf"
once(outfn,"ex-model-test.pdf");
once(draw_down_msgs,1);
once(draw_grid,1);

unlink(outfn)
devh=6
devw=4
pdf(devw,devh,file=outfn,title="output of example-model.R")
par(family="serif")

# draw grid
if(draw_grid) {
  reswin()
  # FHE 24 Sep 2022 no longer square
  grid(devw+1,devh+1,lwd=3);
}

if(draw_down_msgs) {
  mysource("simplefg-B.R")
} else {
  mysource("simplefg.R")
}

dep_edges=ifelse(edges==2,1,0);
arg_edges=ifelse(edges==1,1,0);

#arrowlabels=ifelse(edges>0,"","0");
# reverse dep_edges arrows
arrowlabels=ifelse(arg_edges+t(dep_edges),"","_") # absent="_" below
if(!draw_down_msgs) arrowlabels=t(arrowlabels);

boxtypes=ifelse(nds %in% vars, "circle", "square")
boxcols=ifelse(nds %in% vars, "white", "gray85")

boxsize=0.06
if(draw_down_msgs) boxsize=0.04

reswin()
plotmat(arrowlabels, pos=pos, name=nds,
  curve=0, arr.lwd=1, arr.type="simple", arr.length=0.2,
  box.type=boxtypes, box.col=boxcols, box.size=boxsize,
  shadow.size=0, absent="_",
  txt.font=3 # italic
)

par(new=T,mar=rep(0,4));

if(draw_down_msgs) {
  # FHE 24 Sep 2022
  # make messages correspond
  down_msgs=list(
    "z,B"=1,
    "u,F"=3,
    "v,F"=-1,
    "w,G"=-2,
    "x,G"=0.5,
    "x,H"=0.75,
    "y,H"=1.5,
    "t,J"=-0.3
  );
  down_msgs[["z,F"]]=down_msgs[["z,B"]];
  down_msgs[["u,G"]]=down_msgs[["u,F"]];
  down_msgs[["v,H"]]=down_msgs[["v,F"]];
  down_msgs[["x,J"]]=down_msgs[["x,G"]]+down_msgs[["x,H"]];
  for(n in names(edgeoffs)) {
    vf = varfact(n);
    mid=(pos[vf[1],]+pos[vf[2],])/2
    #mid=(pos["h",]+pos["y",])/2
    mid=mid*c(devw,devh); #FHE 24 Sep 2022 added devw
    placeplot(center_rect(mid,width=0.4,
      adj=edgeoffs[[n]]), { myexpplot(down_msgs[[n]]); });
    # points should line up
    #  points(mid[1],mid[2])
  }
}

dev.off();
system2("dpdf",list(outfn));
