# FHE 24 Sep 2022
# from /home/frederik/bpbp/fg-diag.R
# added devw=4, so no longer square
# 

# FHE ? Apr 2020
# first attempt at drawing a diagram. this became plotfg.R

library(diagram)
mysource("placeplot.R")

mysource("once.R")

# FHE 24 Sep 2022 make it sourceable, see example-model-bare.R
#outfn="ex-model.pdf"
once(outfn,"ex-model-msgs.pdf");
once(draw_down_msgs,1);
once(draw_grid,0);

unlink(outfn)
devh=6
devw=4
pdf(devw,devh,file=outfn,title="output of example-model.R")
par(family="serif")

# draw grid
if(draw_grid) {
  reswin()
  # FHE 24 Sep 2022 no longer square
  grid(devw+1,devh+1,lwd=3);
}

if(0) {
  mysource("simplefg.R")
} else {
  mysource("simplefg-B.R")
}

dep_edges=ifelse(edges==2,1,0);
arg_edges=ifelse(edges==1,1,0);

#arrowlabels=ifelse(edges>0,"","0");
# reverse dep_edges arrows
arrowlabels=ifelse(arg_edges+t(dep_edges),"","_") # absent="_" below

boxtypes=ifelse(nds %in% vars, "circle", "square")
boxcols=ifelse(nds %in% vars, "white", "gray85")

boxsize=0.06
if(draw_down_msgs) boxsize=0.04

reswin()
plotmat(arrowlabels, pos=pos, name=nds,
  curve=0, arr.lwd=1, arr.type="simple", arr.length=0.2,
  box.type=boxtypes, box.col=boxcols, box.size=boxsize,
  shadow.size=0, absent="_",
  txt.font=3 # italic
)

par(new=T,mar=rep(0,4));

if(draw_down_msgs) {
  for(n in names(edgeoffs)) {
    vf = varfact(n);
    mid=(pos[vf[1],]+pos[vf[2],])/2
    #mid=(pos["h",]+pos["y",])/2
    mid=mid*c(devw,devh); #FHE 24 Sep 2022 added devw
    placeplot(center_rect(mid,width=0.4,
      adj=edgeoffs[[n]]), { myexpplot(rnorm(1)*3); });
    # points should line up
    #  points(mid[1],mid[2])
  }
}

dev.off();
system2("dpdf",list(outfn));
