# FHE 29 Sep 2022
# plot for product of Boltzmann distro and Gaussian

xs=seq(-1,1,by=0.01)

gpdf=function(xs,sig) { exp(-(xs/sig)^2)/sqrt(2*pi)/sig }

s1=0.3
ys1=gpdf(xs,s1);

ys2=ys1 * exp(xs);

wmean = function(xs,ys) { sum(xs*ys)/sum(ys) }
m1 = wmean(xs,ys1);
m2 = wmean(xs,ys2);

## wsd = function(xs,ys) {
##   m = wmean(xs,ys);
##   # sqrt(<(x-<x>)^2>)
##   s = sqrt( sum((xs-m)^2*ys)/sum(ys) );
##   c(m,s)
## }

## s_m1=sum(wsd(xs,ys1));
## s_m2=sum(wsd(xs,ys2));

devw=4
devh=2
outfn="gauss_boltz.pdf"
pdf(devw,devh,file=outfn,title="Gaussian times Boltzmann")

par(mar=rep(0.2,4));
par(cex=2) # cex does not control tick size
plot(xs, ys2,t="l",main="",xlab="",ylab="", ylim=range(c(0,ys2)),
    xaxt="n",yaxt="n",bty="n",lty=2)
#abline(v=0,lwd=1);
lines(xs,ys1,type="l",lty=1);
lines(xs,exp(xs)/1.5);
#https://stackoverflow.com/questions/29807447/use-axis-to-draw-axis-without-ticks
axis(1, tcl=0, labels=FALSE, pos=0);

## v=0.4
## arrows(s1,v,s2,v,length=0.1);

tcl=-0.3;
axis(1,at=m1,labels="",lty=1,tcl=tcl,pos=0);
axis(1,at=m2,labels="",lty=2,tcl=tcl,pos=0);

dev.off();
system2("dpdf",list(outfn));
