# FHE 29 Sep 2022
# plot for limit of Gaussians

xs=seq(-1,1,by=0.01)

gpdf=function(xs,sig) { exp(-(xs/sig)^2/2)/sqrt(2*pi)/sig }

s1=0.3
ys1=gpdf(xs,s1);
s2=0.15
ys2=gpdf(xs,s2);

devw=4
devh=2
outfn="gauss_lim.pdf"
pdf(devw,devh,file=outfn,title="two Gaussians")

par(mar=rep(0.2,4));
par(cex=2) # cex does not control tick size
plot(xs, ys2,t="l",main="",xlab="",ylab="", ylim=range(c(0,ys2)),
    xaxt="n",yaxt="n",bty="n")
abline(v=0,lwd=1);
lines(xs,ys1,type="l",lty=2);
#https://stackoverflow.com/questions/29807447/use-axis-to-draw-axis-without-ticks
axis(1, tcl=0, labels=FALSE, pos=0);

v=0.6
arrows(s1,v,s2,v,length=0.1,lwd=1.5);

tcl=-0.3;
axis(1,at=s1,labels=as.character(s1),lty=2,tcl=tcl,pos=0);
axis(1,at=s2,labels=as.character(s2),tcl=tcl,pos=0);

dev.off();
system2("dpdf",list(outfn));
