# FHE 24 Sep 2022 from /home/frederik/bpbp/placeplot.R
# FHE 29 Apr 2020 place a plot on another plot

# placeplot(boundrect, plotexpr): draw a plot at a particular location on the current plot. uses margins to position the plot. calls reswin() afterwards and tries to reset par().
# reswin(): reset plot boundaries to full device (zero to dev.size())
# center_rect(): returns coordinates for a rectangle (x1,y1,x2,y2) with specified center position and height, width
# myexpplot(): example function for testing

reswin = function() {
  suppressWarnings( # "calling par(new=TRUE) with no plot"
    par(new=T,mar=rep(0,4))
  )
  plot.new()
  devh=dev.size()[1]
  devv=dev.size()[2]
  plot.window(
    xlim=c(0, devh), ylim=c(0, devv),
    xaxs="i", yaxs="i"
  )
  par(new=T)
}

# use a 1x1 box (x1,y1,x2,y2)
# "expr" is supposed to draw the actual plot
# until we can figure out how to save the plotting window
placeplot=function(boundrect, plotexpr) {
  br=boundrect
  sz=dev.size()
  br[3:4]=sz-br[3:4];
  op=par(mai=c(br[2],br[1],br[4],br[3]));
  
  exval = eval(plotexpr,parent.frame());
  res = force(exval)
  par(op)
  reswin()
  res
  ## res = paste0(capture.output(exval),collapse="\n");
  ## res
}

center_rect=function(ctr, width, height=width,
  adj=c(0,0)) {
  stopifnot(length(ctr)==2)
  c(ctr,ctr)+c(-width,-height,width,height)/2+adj*c(width,height);
}

# for testing
myexpplot=function(a,...) {
#  message("Plotting, a=",a)
  xs=seq(-1,1,by=0.01);
  ys=exp(a*xs)
  par(new=T)
  par(cex=0.5) # cex does not control tick size
  plot(xs, ys,t="l",main="",xlab="",ylab="", ylim=range(c(0,ys)),
    xaxt="n",yaxt="n",
    ...)
  abline(v=0,lwd=0.5);
}
