# FHE 24 Sep 2022
# copied from /home/frederik/bpbp/simplefg.R

# HACK WARNING
# keep this diff simple:
# diff simplefg.R simplefg-B.R

# FHE 22 May 2020
# based on simplefg.R

# FHE 29 Apr 2020 describe a simple factor graph
# see fg-diag.R

# vars: vector of names of variables
# fcts: vector of names of factors
# nds: vars+fcts, but arranged in order in graph
# edges: nds x nds matrix; 1 for arg var and 2 for dep var (function output)
# pos: nds x 2; gives positions of each variable or factor in output diagram
# varfact(): parse "z,f"
# markedge(): specify a bunch of edges
# edgeoffs: where a message plot should go, relative to the center of each edge

vars=c("w","t","y","u","v","x","z")
fcts=c("j","g","h","f")
nds=strsplit("zfuvghwxyjt",split="")[[1]]
edges=matrix(nrow = length(nds), ncol= length(nds), 0)
dimnames(edges)=list(nds,nds)
## pos=c(1,1,2,2,3,1,1)
{
  # define position of each node/factor in nds
  pcol=c(0,0,-1,1,-1,1,-2,0,2,0,0)
  prow=c(0,1,2,2,3,3,4,4,4,5,6)
  marg=0.5 # XXX for some reason, can't get this below 0.5
  ps=devh+2*marg
  # FHE 24 Sep 2022 no longer square
  psw=devw+2*marg
  #ps=8
  mid=mean(range(prow))
  pos<<-cbind(pcol/psw+marg,(mid-prow)/ps+marg)
}
rownames(pos)=nds
varfact=function(str) { strsplit(str,split=",")[[1]] }
markedge=function(val,...) {
  for(str in c(...)) {
    varfct=varfact(str)
    stopifnot(varfct[1] %in% vars &&
                varfct[2] %in% fcts)
    edges[varfct[1],varfct[2]]<<-val
  }
}
markedge(1,"z,f","u,f","v,f","u,g","w,g","x,g","x,h","v,h","y,h","x,j","t,j")
markedge(2,"z,f","u,g","v,h","x,j")

################################################################
# offsets for showing messages

s=0.7
edgeoffs=list(
  "y,h"=s*c(1,1),
  "x,h"=s*c(1,-1),
  "x,g"=s*c(-1,-1),
  "w,g"=s*c(-1,1),
  "u,g"=s*c(-1,0),
#  "v,g"=s*c(0,0),
#  "w,h"=s*c(0,0),
  "v,h"=s*c(1,0),
  "u,f"=s*c(-1,1),
  "v,f"=s*c(1,1),
  "z,f"=s*c(1,0),
  "x,j"=s*c(-1,0),
  "t,j"=s*c(1,0)
)

